let pToPolC: Pol.t -> PolC.PolLinQ.t
= fun p -> Some {PolC.PolLinQ.cons = Support.pToConsSet p; PolC.PolLinQ.ml = p}

let polChkSync: PolC.PolLinQ.t -> bool
= function
	| None -> true
	| Some p ->
		match pToPolC (PolC.PolLinQ.ml p) with
		| None -> failwith "Glue.polChkSync"
		| Some pML ->
			let norm: ConsSet.Cs.t -> ConsSet.Cs.t
			= fun cs ->
				let sort: ConsSet.Cs.t -> ConsSet.Cs.t
				= fun cs ->
					let cmp: ConsSet.Cs.cT -> ConsSet.Cs.cT -> int
					= fun c1 c2 -> Pervasives.compare (ConsSet.Cs.id c1) (ConsSet.Cs.id c2)
					in
					List.sort cmp cs
				in
                                (* TODO (from Sylvain): normDep does not exist anymore in the new implementation of linterms...
                                        but it may be useful to test the implicit invariant (by adding a test function in LinTerm.v)
				let norm1: ConsSet.Cs.cT -> ConsSet.Cs.cT
				= fun c ->
					{c with ConsSet.Cs.cstr =
						{(ConsSet.Cs.cstr c) with CstrC.Cstr.coefs =
							LinTerm.Lin.normDep (CstrC.Cstr.coefs (ConsSet.Cs.cstr c))}}
				in
				 *)
				sort cs (* Sylvain: (List.map norm1 cs) *)
			in
			let normP = norm (PolC.PolLinQ.cons p) in
			let normPML = norm (PolC.PolLinQ.cons pML) in
			normP = normPML

let addC: Pol.t -> Cstr.t -> PolC.PolLinQ.t
= fun p c ->
	let coqP = pToPolC p in
	let coqC = Support.cToQCond c in
	PolC.PolLinQ.assume coqC coqP

let meet: Pol.t -> Pol.t -> PolC.PolLinQ.t
= fun p1 p2 -> PolC.PolLinQ.meet (pToPolC p1) (pToPolC p2)

let isInclC: Pol.t -> Pol.t -> bool
= fun p1 p2 -> PolC.PolLinQ.isIncl (pToPolC p1) (pToPolC p2)

let joinC: Pol.t -> Pol.t -> PolC.PolLinQ.t
= fun p1 p2 -> PolC.PolLinQ.join (pToPolC p1) (pToPolC p2)

let getItvC: Pol.t -> Vec.t -> Pol.itvT
= fun p v -> Support.iToItv (PolC.PolLinQ.getItv (pToPolC p) (Support.vecToLt v))

let project: Pol.t -> Var.t -> PolC.PolLinQ.t
= fun p1 x -> PolC.PolLinQ.project (pToPolC p1) (Support.varToProgVar x)

let projectM: Pol.t -> Var.t list -> Pol.t
= fun p l ->
	let (p', ce) = Pol.projectM p l in
	let cs = Support.pToConsSet p in
	let cs' = Support.pToConsSet p' in
	let ce' = Support.cToCertC ce in
	if ConsSet.Cs.chkIncl cs cs' ce'
	then p'
	else Pervasives.failwith "checking error"
